SystemOrganization addCategory: #'Pier-Debugging'!

!WAGlobalConfiguration class methodsFor: '*pier-debugging-override' stamp: 'kph 8/17/2007 08:04'!
setDeploymentMode
	DeploymentMode := true.
	
	Preferences allPreferenceObjects do: [ :each | 
		
		(each categoryList includes: PRDebugging category) ifTrue: [ each restoreDefaultValue  ]
		
	].! !

!PRContentsWidget methodsFor: '*pier-debugging-override' stamp: 'kph 8/19/2007 04:14'!
onAnswerCommand: aCommand
	aCommand isNil
		ifTrue: [ ^ self context: (self context structure: self context structure) ].
	[ aCommand execute ]
		on: Error
		do: [ :err | 
			 
			Preferences debugPierFormErrors ifTrue: [ err pass ].
			
			^ self component errors add: err.  ].
	self context: aCommand answer! !

!Object methodsFor: '*pier-debugging' stamp: 'kph 8/17/2007 07:36'!
helpfulError: msg

	Preferences helpfulErrors ifTrue: [ self error: msg ].! !

Object subclass: #PRDebugging
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'seaside debug'!

!PRDebugging class methodsFor: 'as yet unclassified' stamp: 'kph 8/17/2007 07:58'!
initialize
 
	Preferences addBooleanPreference: #helpfulErrors categories: self categories default: false balloonHelp: 'Enable helpful errors. (See senders of #helpfulError:)'.
		
	Preferences addBooleanPreference: #haltOnForbidden categories:  self categories default: false balloonHelp: 'Halt when user accesses a forbidden page'.
	
	Preferences addBooleanPreference: #haltOnDbCommit categories:  self categories default: false balloonHelp: 'Halt when write is made to database (if you have one)'. 
	
	Preferences addBooleanPreference: #debugInvalidLogin categories:  self categories default: false balloonHelp: 'Halt when pier login is invalid'.
	
	Preferences addBooleanPreference: #debugPierFormErrors categories:  self categories default: false balloonHelp: 'Halt when pier form validaton error occurs'.
	
	Preferences addBooleanPreference: #dbLogEveryRowReturned categories:  self categories default: false balloonHelp: 'Log everything returned from a db query'.

! !

!PRDebugging class methodsFor: 'as yet unclassified' stamp: 'kph 8/17/2007 07:57'!
categories

	^ #( #'seaside debug' )! !

!PRDebugging class methodsFor: 'as yet unclassified' stamp: 'kph 8/17/2007 07:57'!
category

	^ #'seaside debug'! !

!WAComponent methodsFor: '*pier-debugging-override' stamp: 'kph 8/17/2007 06:59'!
decoration
	decoration ifNil: [ self error: 'I bet you didnt put super initialize in that new component did you?' ].
	^ decoration contents! !

!PULogin methodsFor: '*pier-debugging-override' stamp: 'kph 8/16/2007 15:56'!
invalidLogin

	Preferences haltOnInvalidLogin ifTrue: [ self halt ].

	PUInvalidLogin
		description: self description
		signal: 'Invalid username or password.'! !

!PRPierMain methodsFor: '*pier-debugging-override' stamp: 'kph 8/22/2007 23:00'!
forbidden: aRequest

	| page command |
	
	Preferences haltOnForbidden  ifTrue: [ self halt ].

	"self return: (WAResponse forbidden: aRequest url)"

	self context: (PRContext kernel: self kernel).

	page :=	PRPathLookup
		start: self kernel root path: '/site/access+denied'
		onError: [ self notFound: aRequest ].
		

	PRCurrentContext use: self during: [
		command :=	 page defaultCommandClass  new
			setContext: self context;
			initialRequest: aRequest;
			yourself.
			
		self context
			setStructure: page;
			setCommand: command.
		self context isValid
			ifFalse: [ self halt. self return: (WAResponse forbidden: aRequest url) ] ].

	super start: aRequest! !

!MADescription methodsFor: '*pier-debugging-override' stamp: 'kph 9/13/2007 23:13'!
conflictErrorMessage

	Preferences debugPierFormErrors ifTrue: [ self halt ].

	^ self propertyAt: #conflictErrorMessage ifAbsent: [ 'Input is conflicting with concurrent modification' ]! !

!MADescription methodsFor: '*pier-debugging-override' stamp: 'kph 8/19/2007 02:55'!
kindErrorMessage

 
   Preferences debugPierFormErrors ifTrue: [ self halt ].
	^ self propertyAt: #kindErrorMessage ifAbsent: [ 'Invalid input given' ]! !

!MADescription methodsFor: '*pier-debugging-override' stamp: 'kph 9/13/2007 23:14'!
multipleErrorsMessage

	Preferences debugPierFormErrors ifTrue: [ self halt ].

	^ self propertyAt: #multipleErrorsMessage ifAbsent: [ 'Multiple errors' ]! !

!MADescription methodsFor: '*pier-debugging-override' stamp: 'kph 9/13/2007 23:14'!
requiredErrorMessage

	Preferences debugPierFormErrors ifTrue: [ self halt ].

	^ self propertyAt: #requiredErrorMessage ifAbsent: [ 'Input is required but no input given' ]! !
PRDebugging initialize!
